% !TEX program = LuaLaTeX+se
\documentclass[12pt,a4paper]{article}
\usepackage[titletoc,toc,title]{appendix}
\usepackage{fontspec}
\defaultfontfeatures{Ligatures=TeX}
\setmainfont[
		BoldFont=LinLibertineOZ,
		BoldItalicFont=LinLibertineOZI,
		SmallCapsFont=LinLibertineO,
		SmallCapsFeatures={Letters=SmallCaps},
]{LinuxLibertineO}
\setsansfont[Extension=.otf,
		BoldFont=LinBiolinum_RB,
		ItalicFont=LinBiolinum_RI,
		BoldItalicFont=LinBiolinum_RB,% fake
		SmallCapsFont=LinBiolinum_R,
		SmallCapsFeatures={Letters=SmallCaps},
		]{LinBiolinum_R}
\setmonofont[Extension=.otf,
		ItalicFont=Inconsolatazi4-Regular,
		BoldFont=Inconsolatazi4-Bold,
		BoldItalicFont=Inconsolatazi4-Bold,
		AutoFakeSlant,
		ItalicFeatures={FakeSlant},
		BoldItalicFeatures={FakeSlant}
		]{Inconsolatazi4-Regular}
\usepackage{enumitem}
\usepackage{xspace}
\usepackage{multicol}
\usepackage{units}
\usepackage{framed}
\usepackage{url}
\usepackage{tabulary}
\usepackage{tabularx}
\usepackage{adjustbox}
\usepackage{xparse}

\usepackage{makeidx}
\makeindex

\usepackage[table]{xcolor}
\definecolor{lightgray}{gray}{0.9}
\definecolor{green}{HTML}{0c700c}
\definecolor{myred}{HTML}{FF3333}

\usepackage{minted} % must be after xcolor
\makeatletter
\@ifpackagelater{minted}{2013/12/21}{%
	\newminted{latex}{autogobble,bgcolor=lightgray}%
}{%
	\newminted{latex}{gobble=2,bgcolor=lightgray}%
}%
\makeatother
%\newminted{gabc}{bgcolor=lightgray} % can this be done?
\newenvironment{gabccode}{\tt}{}


\usepackage[allowdeprecated=false]{gregoriotex}

\usepackage{carolmin}
\usepackage{mflogo}

\usepackage{hyperref}
\hypersetup{colorlinks, citecolor=black, filecolor=black, linkcolor=green, urlcolor=green}

\usepackage{longtable}
\usepackage{multirow}
\usepackage{pdflscape}
\usepackage{hhline}
\usepackage{listings}
\usepackage{lstautogobble}
\directlua{dofile('GregorioRef.lua')}

\newcommand*{\eg}{e.g.\@\xspace}
\newcommand*{\nb}{n.b.\@\xspace}
\newcommand*{\ie}{i.e.\@\xspace}
\newcommand*{\etc}{etc.\@\xspace}

\newif\ifbreakable
\let\oldsubsection\subsection
\def\subsection{\filbreak\breakablefalse\oldsubsection}
\let\oldsubsubsection\subsubsection
\def\subsubsection{\filbreak\breakablefalse\oldsubsubsection}

\newcommand{\macroname}[3]{%
	\vspace{3.25ex plus 1ex minus .2ex}%
	\ifbreakable%
		\filbreak%
	\else%
		\breakabletrue%
	\fi%
	\makebox[\linewidth]{\ttfamily\bfseries #1#2%
	\hspace{\fill}\normalfont\itshape #3}%
	\vspace{1.5ex plus .2ex}%
	\index{#1}}
	%\addcontentsline{toc}{subsubsection}{#1}}

\newcommand{\optional}[1]{{\itshape #1}}

\lstset{backgroundcolor=\color{lightgray},
				basicstyle=\small\ttfamily,
				numbers=left,
				numberstyle=\footnotesize,
				stepnumber=1,
				numbersep=5pt}

% for the character tables
\font\greciliae = {name:greciliae} at 1000000 sp\relax
\font\gregorio = {name:gregorio} at 1000000 sp\relax
\font\parmesan = {name:parmesan} at 1000000 sp\relax
\font\greciliaeOp = {name:greciliae-op} at 1000000 sp\relax
\font\gregorioOp = {name:gregorio-op} at 1000000 sp\relax
\font\parmesanOp = {name:parmesan-op} at 1000000 sp\relax
\font\greextra = {name:greextra} at 12 pt\relax
\newcommand{\excluded}[1]{{\tiny\itshape #1}}

\newenvironment{argtable}{%
	\bigskip\rowcolors{1}{lightgray}{lightgray}
	\tabularx{\textwidth}{clX}
		Arg & Value & Description \\
		\hline}%
	{\endtabularx\bigskip}

\makeatletter%
\NewDocumentEnvironment{gdimension}{m}{\macroname{#1}{}{gsp-default.tex}}{%

	\gre@rubberpermit{#1}%
	\ifgre@rubber%
		Default: \directlua{GregorioRef.emit_dimension("\luaescapestring{\csname gre@space@skip@#1\endcsname}")}
	\else%
		Default: \directlua{GregorioRef.emit_dimension("\luaescapestring{\csname gre@space@dimen@#1\endcsname}")}
	\fi%
}

\newcommand{\writemode}[3]{%
	\gre@style@modeline #1\endgre@style@modeline %
	\gre@style@modemodifier #2\endgre@style@modemodifier %
	\gre@style@modedifferentia #3\endgre@style@modedifferentia %
}
\makeatother

\setlength{\parindent}{0mm} % Default is 15pt

\begin{document}

\begin{titlepage}
	\begin{center}
		\Huge
		\textcolor{myred}{Gregorio} and \textcolor{myred}{Gregorio\TeX}:

		Tools for gregorian score engraving.

		\vspace{1cm}

		\large Version \textbf{4.1.1}, 10 March 2016 %% PARSE_VERSION_DATE

		\vspace{1.5cm}
	\end{center}
	\gresetlinecolor{gregoriocolor}
	\grechangestyle{lowchoralsign}{\cminfamily\small}%
	\grechangestyle{highchoralsign}{\cminfamily\small}%
	\def\GreStar{\greheightstar}%
	\greannotation{\scriptsize Comm.}%
	\greannotation{\scriptsize VII}%
	\begingroup%
		\color{black!60}%
		\setmainfont[SmallCapsFont=AlegreyaSC]{Alegreya}%
		\newlength{\mini}%
		\setlength{\mini}{\hsize}%
		\addtolength{\mini}{-4cm}%
		\setlength{\fboxsep}{5mm}%
		\hfill\fbox{\parbox{\mini}{\gregorioscore[f]{factus}}}\hfill%
	\endgroup
	\begin{center}
		\vspace{1.5cm}%
		\href{http://gregorio-project.github.io/}{Homepage}

		Source code available on
		\href{http://github.com/gregorio-project/gregorio}{GitHub}.
	\end{center}

	\vspace{2cm}
\end{titlepage}

\cleardoublepage

\tableofcontents

\setlength{\parskip}{\bigskipamount}
\cleardoublepage

\section{Gregorio\TeX{} Macros}
The following sections document the macros available in the Gregorio\TeX{} package. The format is as follows:

\macroname{MacroName}{\{Args\}}{Source File}
Description of macro.

\begin{argtable}
	Arg \# & Data type & Description of argument\\
	Arg \# & \texttt{keyword} & Description of the setting the keyword corresponds to
\end{argtable}

The source file where the macro is defined is included for developers
who wish to consult it.

Some of the macros intended for inclusion in the main.tex file by the user
include usage examples.

Macros are divided into three groups:
\begin{description}
\item[User Commands] These macros are meant to be used by your average user in their \TeX\ files in order to fine tune the appearance of their scores.  They should have names which consist solely of lowercase letters and be prefixed with the \texttt{gre}.  Where the name clearly identifies the function as belonging to Gregorio\TeX, the prefix may be omitted.
\item[Gregorio Controls] These macros are written by the command line tool to gtex files and should not appear outside of gtex files.  They should have names which are in CamelCase and be prefixed with \texttt{Gre}.
\item[Gregorio\TeX\ internals] These macros are used by Gregorio\TeX\ to process and typeset a score and should not appear in a user's document anywhere (not even in gtex files).  They should have names which are all lowercase and be prefixed with \makeatletter\texttt{gre@}\makeatother.
\end{description}


\include{Command_Index_User}
\include{Command_Index_gregorio}
\include{Command_Index_internal}
\include{Gabc}

\begin{appendices}
	%Turn off the \filbreak stuff to prevent it from messing up the long tables in the appendicies
	\let\subsection\oldsubsection
	\let\subsubsection\oldsubsubsection
	\renewcommand\thetable{\thesection\arabic{table}}
	\renewcommand\thefigure{\thesection\arabic{figure}}
	\include{Appendix_Font_Tables}
\end{appendices}

\addcontentsline{toc}{section}{Index}
\printindex

\end{document}
